Main Page Class Hierarchy Data Structures File List Data Fields Globals

# pv_2way_basic_types.h File Reference

`#include "pvmf_format_type.h"`
`#include "oscl_vector.h"`
`#include "oscl_mem.h"`

Go to the source code of this file.

## Data Structures
class | PV2WayConnectOptions
class | PV2WayInitInfo
## Typedefs
typedef enum TPVTerminalType | PV2WayTerminalType
typedef enum TPVLoopbackMode | PV2WayLoopbackMode
typedef enum TPVDirection | PV2WayDirection
typedef enum TPVMediaType_t | PV2WayMediaType
typedef unsigned int | PVTrackId
## Enumerations
enum | TPVTerminalType { PV_323, PV_324M, PV_SIP, PV_TERMINAL_TYPE_NONE }
enum | TPVLoopbackMode { PV_LOOPBACK_NONE, PV_LOOPBACK_COMM, PV_LOOPBACK_ENGINE, PV_LOOPBACK_MUX }
enum | TPVDirection { PV_DIRECTION_NONE = 0, INCOMING = 1, OUTGOING = 2, PV_DIRECTION_BOTH = 3 }
enum | TPVMediaType_t { PV_MEDIA_NONE = 0, PV_CONTROL = 1, PV_AUDIO = 2, PV_VIDEO = 4, PV_DATA = 8, PV_USER_INPUT = 16, PV_MULTIPLEXED = 32, PV_MEDIA_ALL = 0xFFFF }
enum | PV2WayState { EIdle = 0, EInitializing, ESetup, EConnecting, EConnected, EDisconnecting, EResetting }
enum | TPVTIndicationType { PVT_INDICATION_INCOMING_TRACK, PVT_INDICATION_OUTGOING_TRACK, PVT_INDICATION_DISCONNECT, PVT_INDICATION_CLOSING_TRACK, PVT_INDICATION_CLOSE_TRACK, PVT_INDICATION_PAUSE_TRACK, PVT_INDICATION_RESUME_TRACK, PVT_INDICATION_INTERNAL_ERROR }
## Variables
const int | PV2WayErrorStatusStart = (-10500)
const int | PV2WayDispatchError = PV2WayErrorStatusStart - 1
const int | PV2WayDisconnectError = PV2WayErrorStatusStart - 2
const int | PV2WayErrorRejected = PV2WayErrorStatusStart - 5
const int | PV2WayErrReplaced = PV2WayErrorStatusStart - 6

## Typedef Documentation

typedef enum TPVDirection PV2WayDirection

| TPVDirection Enum TPVDirection emumerates the direction of the track.

typedef enum TPVLoopbackMode PV2WayLoopbackMode

| TPVLoopbackMode Enum TPVLoopbackMode emumerates the possible loopback options that can be used with the pv2way SDK

typedef enum TPVMediaType_t PV2WayMediaType

| Enumeration of high level media types supported by the SDK

typedef enum TPVTerminalType PV2WayTerminalType

| TPVTerminalType enum TPVTerminalType enumerates the possible 2-way protocols

typedef unsigned int PVTrackId

| PVTrackId uniquely identifies a track for transferring audio/video in a particular direction - receive or transmit.

## Enumeration Type Documentation

enum PV2WayState

  | TPV2WayState Class An enumeration of the major states of the pv2way engine. Enumeration values:
  EIdle | The state immediately after the pv2way instance has been successfully created or instantiated. No resources have been allocated yet.
  EInitializing | The pv2way is in this state when it is initializing from the EIdle to the ESetup state. The terminal queries the available device capabilities (encode, decode, mux), acquires resources to make a two-way call (codecs, formats, memory etc) and transitions to the ESetup state when it will be ready to accept setup parameters and Connect. If initializing fails, the pv2way relinquishes the resources and reverts to the EIdle state.
  ESetup | The state where the pv2way instance is in the process of receiving setup parameters from the application, for encoding, multiplexing, capturing and rendering. Each time a new set of parameters is passed in, validation will take place and a status will be returned accordingly. A valid data source and data sink for the communications port are to be added to the terminal in this state before it can be transitioned to the Econnecting state. Media sources and sinks can also be added at this time.
  EConnecting | The state where the pv2way instance has received a call to start connecting. It starts communication with the remote terminal to exchange media capabilities and channel configuration in preparation for the establishment of media channels.
  EConnected | The state after all control signaling is completed. The terminal is now able to open media tracks for audio and video.
  EDisconnecting | The state where the terminal is shutting down all tracks and the multiplex.
  EResetting | The state where the terminal is releasing all resources and transitioning to the EIdle state.

enum TPVDirection

  | TPVDirection Enum TPVDirection emumerates the direction of the track. Enumeration values:
  PV_DIRECTION_NONE |
  INCOMING |
  OUTGOING |
  PV_DIRECTION_BOTH |

enum TPVLoopbackMode

  | TPVLoopbackMode Enum TPVLoopbackMode emumerates the possible loopback options that can be used with the pv2way SDK Enumeration values:
  PV_LOOPBACK_NONE |
  PV_LOOPBACK_COMM |
  PV_LOOPBACK_ENGINE |
  PV_LOOPBACK_MUX |

enum TPVMediaType_t

  | Enumeration of high level media types supported by the SDK Enumeration values:
  PV_MEDIA_NONE |
  PV_CONTROL |
  PV_AUDIO |
  PV_VIDEO |
  PV_DATA |
  PV_USER_INPUT |
  PV_MULTIPLEXED |
  PV_MEDIA_ALL |

enum TPVTerminalType

  | TPVTerminalType enum TPVTerminalType enumerates the possible 2-way protocols Enumeration values:
  PV_323 |
  PV_324M |
  PV_SIP |
  PV_TERMINAL_TYPE_NONE |

enum TPVTIndicationType

  | TPVTIndicationType enum Enumeration of unsolicited indications from pv2way. Enumeration values:
  PVT_INDICATION_INCOMING_TRACK | Indicates that the peer terminal has established an incoming track. The local buffer specifies the media type associated with the track. The first octet of the local buffer indicates the media type. The second,third and fourth octets are reserved. The four octets from five to eight are to be interpreted as a unique track id. The format type and additional capabilities are indicated using the PV2WayTrackInfoInterface extension interface.
  PVT_INDICATION_OUTGOING_TRACK | Indicates that the local terminal has established an outgoing track that is acceptable to the peer. The local buffer specifies the media type associated with the track. The first octet of the local buffer indicates the media type. The second,third and fourth octets are reserved. The four octets from five to eight are to be interpreted as a unique track id. The format type and additional capabilities are indicated using the PV2WayTrackInfoInterface extension interface.
  PVT_INDICATION_DISCONNECT | Indicates that 2way engine has ended the current telephony session. The app can now either reset the engine or make a subsequent call.
  PVT_INDICATION_CLOSING_TRACK | Indicates the start of unsolicited closure of an incoming/outgoing track. The PVT_INDICATION_CLOSE_TRACK indication will be sent when the track is completely close. The first octet of the local buffer indicates the direction of the track. The second and third octets indicates the track id.
  PVT_INDICATION_CLOSE_TRACK | Indicates an unsolicited closure of an incoming/outgoing track. Any media sink/source associated with this will be stopped and returned to the application. The first octet of the local buffer indicates the media type of the track. The second octet indicates the direction. The third octet indicates whether there is a replacement for this track available. If true, the application may add data source/sink for this track again.
  PVT_INDICATION_PAUSE_TRACK | Indicates that local terminal has paused an incoming track. Any media sink associated with this will be stopped. The first octet of the local buffer indicates the direction of the track. The second and third octets indicates the track id.
  PVT_INDICATION_RESUME_TRACK | Indicates that local terminal has resumed an incoming track. Any media sink associated with this will be restarted. The first octet of the local buffer indicates the direction of the track. The second and third octets indicates the track id.
  PVT_INDICATION_INTERNAL_ERROR | Indicates an internal error in the pv2way engine. The derived class provides further information about the actual error.

## Variable Documentation

const int PV2WayDisconnectError = PV2WayErrorStatusStart - 2

| The peer disconnected without endsession command *

const int PV2WayDispatchError = PV2WayErrorStatusStart - 1

| There was an error dispatching muxed data to the downstream node *

const int PV2WayErrorRejected = PV2WayErrorStatusStart - 5

| The request was rejected by the peer *

const int PV2WayErrorStatusStart = (-10500)

| The starting error code for 2way specific errors *

const int PV2WayErrReplaced = PV2WayErrorStatusStart - 6

| Signals replacement of an existing resource *